#include "gens.h"
#include <stdlib.h>
#include <time.h>
#include <SDL.h>
#include <math.h> //Modif IM
#include <X11/Xlib.h> //Modif IM - massive var name changes due to this
#include <stdio.h>
#include <string.h>
#include "SDL_syswm.h"  //Modif IM
#include "timer.h"
#include "g_main.h"
#include "g_ddraw.h"
#include "g_dsound.h"
#include "g_input.h"
#include "ram_search.h"
#include "movie.h"
#include "debug.h"
#include "rom.h"
#include "save.h"
#include "resource.h"
#include "misc.h"
#include "blit.h"
#include "ggenie.h"
#include "cpu_68k.h"
#include "star_68k.h"
#include "cpu_sh2.h"
#include "cpu_z80.h"
#include "z80.h"
#include "mem_m68k.h"
#include "mem_s68k.h"
#include "mem_sh2.h"
#include "mem_z80.h"
#include "io.h"
#include "psg.h"
#include "ym2612.h"
#include "pwm.h"
#include "scrshot.h"
#include "vdp_io.h"
#include "vdp_rend.h"
#include "vdp_32x.h"
#include "lc89510.h"
#include "gfx_cd.h"
#include "cd_aspi.h"
//#include "net.h"
#include "pcm.h"
//#include "htmlhelp.h"
//#include "CCnet.h"
#include "wave.h"
#include "port.h"
#include <readline/readline.h> //Modif IM - nice tab completion for cli input


#ifdef WITH_GTK

#include <gtk/gtk.h>
#include "glade/interface.h"
#include "glade/support.h"

GtkWidget *gens_window;


#else
#define sync_gens_ui()
#define open_game_genie()
#endif




extern SDL_Surface *surface;


bool use_joystick = false;
extern unsigned char key[1024];
SDL_Joystick* joy[2];
SDL_SysWMinfo swi; //Modif IM - slick focus-changing stuff
SDL_Event event; //Modif IM - make reading game keys easier

extern "C" void Read_To_68K_Space(int adr);

//#define WM_KNUX WM_USER + 3

#define GENS_VERSION   2.12
#define GENS_VERSION_H 2 * 65536 + 10


#define MINIMIZE								\
if (Sound_Initialised) Clear_Sound_Buffer();	\
if (Full_Screen)								\
{												\
	Set_Render(HWnd, 0, -1, true);				\
	FS_Minimised = 1;							\
}

#if 0
#define MENU_L(smenu, pos, flags, id, str, suffixe, def)										\
GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);	\
strcat(Str_Tmp, (suffixe));																			\
InsertMenu((smenu), (pos), (flags), (id), Str_Tmp);

#define WORD_L(id, str, suffixe, def)															\
GetPrivateProfileString(language_name[Language], (str), (def), Str_Tmp, 1024, Language_Path);	\
strcat(Str_Tmp, (suffixe));																			\
SetDlgItemText(hDlg, id, Str_Tmp);



HINSTANCE ghInstance;
HACCEL hAccelTable;
WNDCLASS WndClass;
HWND HWnd;
HMENU Gens_Menu;
#endif

POINT Window_Pos;
HMENU Gens_Menu;
Window RootWindow,ParentWindow;
Window *ChildrenList;
unsigned int ChildrenCount;
int HWnd;
char Str_Tmp[1024];
char Gens_Path[1024];
char Language_Path[1024];
char CGOffline_Path[1024];
char Manual_Path[1024];

char **language_name = NULL;
struct Rom *Game = NULL;
int Active = 1;
int Paused = 0;
int Net_Play = 0;
int Full_Screen = -1;
int Resolution = 1;
int Fast_Blur = 0;
int Render_W = 0;
int Render_FS = 0;
int Show_FPS = 0;
int Show_Message = 0;
int Show_LED = 0;
int FS_Minimised = 0;
int Auto_Pause = 0;
int Auto_Fix_CS = 0;
int Language = 0;
int Country = -1;
int Country_Order[3];
int Kaillera_Client_Running = 0;
int Intro_Style = 2;
int SegaCD_Accurate = 0;
int Gens_Running = 0;
int WinNT_Flag = 0;
int Gens_Priority;
int SS_Actived;
int SpeedChangeFactor = 0; //Modif IM - skip 2**SpeedChangeFactor - 1 frames
int SpeedChangeEnabled = 0; //Modif N/IM
int FrameAdvanceEnabled = 0; //Modif N/IM
int FrameCounterEnabled; //Modif N/IM
int FrameCounterPosition; //Modif N/IM
int ShowInputEnabled; //Modif N/IM
int AutoBackupEnabled; //Modif N/IM
int WindowX;//Modif IM
int WindowY;//Modif IM
int DisableBlueScreen; //Modif N/IM
int swi_init = 0;     //Modif IM
int PlayCLIMovie = 0; //Modif IM
extern long unsigned int FrameCount;

SDL_keysym Pause_Emulator_key;
SDL_keysym Quit_key;
SDL_keysym Take_Screenshot_key;
SDL_keysym Fast_Forward_key;
SDL_keysym Reset_key;
SDL_keysym Lower_Speed_key;
SDL_keysym Raise_Speed_key;
SDL_keysym Toggle_Fullscreen_key;
SDL_keysym Change_Stretch_key;
SDL_keysym Auto_Frameskip_key;
SDL_keysym Change_Vsync_key;
SDL_keysym Lower_Frameskip_key;
SDL_keysym Raise_Frameskip_key;
SDL_keysym Save_Current_State_key;
SDL_keysym Alt_Save_Current_State_key;
SDL_keysym Select_Previous_State_key;
SDL_keysym Select_Next_State_key;
SDL_keysym Load_Current_State_key;
SDL_keysym Alt_Load_Current_State_key;
SDL_keysym Change_Blit_Style_key; 
SDL_keysym Toggle_Fast_Blur_key;
SDL_keysym Toggle_Improved_DAC_key;
SDL_keysym Toggle_FPS_Display_key;
SDL_keysym Toggle_Improved_PSG_key;
SDL_keysym Previous_Rendering_Mode_key;
SDL_keysym Toggle_Improved_YM2612_key;
SDL_keysym Next_Rendering_Mode_key;
SDL_keysym Select_State_0_key;
SDL_keysym Select_State_1_key;
SDL_keysym Select_State_2_key;
SDL_keysym Select_State_3_key;
SDL_keysym Select_State_4_key;
SDL_keysym Select_State_5_key;
SDL_keysym Select_State_6_key;
SDL_keysym Select_State_7_key;
SDL_keysym Select_State_8_key;
SDL_keysym Select_State_9_key;
SDL_keysym Load_State_0_key;
SDL_keysym Load_State_1_key;
SDL_keysym Load_State_2_key;
SDL_keysym Load_State_3_key;
SDL_keysym Load_State_4_key;
SDL_keysym Load_State_5_key;
SDL_keysym Load_State_6_key;
SDL_keysym Load_State_7_key;
SDL_keysym Load_State_8_key;
SDL_keysym Load_State_9_key;
SDL_keysym Save_State_0_key;
SDL_keysym Save_State_1_key;
SDL_keysym Save_State_2_key;
SDL_keysym Save_State_3_key;
SDL_keysym Save_State_4_key;
SDL_keysym Save_State_5_key;
SDL_keysym Save_State_6_key;
SDL_keysym Save_State_7_key;
SDL_keysym Save_State_8_key;
SDL_keysym Save_State_9_key;
SDL_keysym Close_ROM_key;
SDL_keysym Open_Game_Genie_key;
SDL_keysym Change_SegaCD_Syncro_key;
SDL_keysym Start_Playing_GYM_key;
SDL_keysym Change_CD_key;
SDL_keysym Toggle_WAV_Dumping_key;
SDL_keysym RAM_Search_Menu_key;
SDL_keysym Start_Recording_key;
SDL_keysym Toggle_Readonly_key;
SDL_keysym Play_Movie_key;
SDL_keysym Toggle_Frame_Counter_key;
SDL_keysym Advance_Frame_key;
SDL_keysym Toggle_Input_Display_key;
SDL_keysym Toggle_Sound_key;
SDL_keysym Stop_Movie_key;
SDL_keysym Record_New_Movie_key;
SDL_keysym Load_State_File_key;
SDL_keysym Save_State_File_key;
SDL_keysym Save_Config_File_key;

//Modif IM - ignore caps lock, etc when checking modifiers for button presses
SDLMod ignore_mods = (SDLMod)(KMOD_NUM | KMOD_CAPS | KMOD_MODE | KMOD_RESERVED); 

int NbRerecord=0;

struct type_MovieFrame
{
	char P1;
	char P2;
	char PX;
};

type_MovieFrame *MovieData = NULL;

#ifdef __PORT__
void win2linux(char* str)
{
	char* tmp=str;
	for (; *tmp; ++tmp)
	{
		switch(*tmp)
		{
			case 0xE7: *tmp='c';break;//
			case 0xE8: *tmp='e';break;//
			case 0xE9: *tmp='e';break;//
			case 0xEA: *tmp='e';break;//
			case 0xE0: *tmp='a';break;//
			case 0xEE: *tmp='i';break;//
			default:break;
		}	
	}
}
#endif

void SetWindowText(int hw, const char *s)
{
  SDL_WM_SetCaption(s,NULL);
}

int Set_Render(HWND hWnd, int Full, int Num, int Force)
{
	int Old_Rend, *Rend;
	void (**Blit)(unsigned char*, int, int, int, int);
	
	if (Full)
	{
		Rend = &Render_FS;
		Blit = &Blit_FS;
	}
	else
	{
		Rend = &Render_W;
		Blit = &Blit_W;
	}

	Old_Rend = *Rend;
	Flag_Clr_Scr = 1;
	
	switch(Num)
	{
		case -1:
			switch(Old_Rend)
			{
				case 0:
					if (Have_MMX) *Blit = Blit_X1_MMX;
					else *Blit = Blit_X1;
					break;

				case 1:
					if (Have_MMX) *Blit = Blit_X2_MMX;
					else *Blit = Blit_X2;
					break;

				case 2:
					if (Have_MMX) *Blit = Blit_X2_Int_MMX;
					else *Blit =  Blit_X2_Int;
					break;

				case 3:
					if (Have_MMX) *Blit = Blit_Scanline_MMX;
					else *Blit = Blit_Scanline;
					break;

				case 4:
					if (Have_MMX) *Blit = Blit_Scanline_50_MMX;
					else
					{
						*Rend = 1;
						*Blit = Blit_X2;
					}
					break;

				case 5:
					if (Have_MMX) *Blit = Blit_Scanline_25_MMX;
					else
					{
						*Rend = 1;
						*Blit = Blit_X2;
					}
					break;

				case 6:
					if (Have_MMX) *Blit = Blit_Scanline_Int_MMX;
					else *Blit = Blit_Scanline_Int;
					break;

				case 7:
					if (Have_MMX) *Blit = Blit_Scanline_50_Int_MMX;
					else
					{
						*Rend = 1;
						*Blit = Blit_X2;
					}
					break;

				case 8:
					if (Have_MMX) *Blit = Blit_Scanline_25_Int_MMX;
					else
					{
						*Rend = 1;
						*Blit = Blit_X2;
					}
					break;

				case 9:
					if (Have_MMX) *Blit = Blit_2xSAI_MMX;
					else
					{
						*Rend = 1;
						*Blit = Blit_X2;
					}
					break;

				default:
					*Rend = 1;
					if (Have_MMX) *Blit = Blit_X2_MMX;
					else *Blit = Blit_X2;
					break;
			}
			break;

		case 0:
			*Rend = 0;
			if (Have_MMX) *Blit = Blit_X1_MMX;
			else *Blit = Blit_X1;
			MESSAGE_L("Render selected : NORMAL", "Render selected : NORMAL", 1500)
			break;

		case 1:
			*Rend = 1;
			if (Have_MMX) *Blit = Blit_X2_MMX;
			else *Blit = Blit_X2;
			MESSAGE_L("Render selected : DOUBLE", "Render selected : DOUBLE", 1500)
			break;

		case 2:
			*Rend = 2;
			if (Have_MMX) *Blit = Blit_X2_Int_MMX;
			else *Blit = Blit_X2_Int;
			MESSAGE_L("Render selected : INTERPOLATED", "Render selected : INTERPOLATED", 1500)
			break;

		case 3:
			*Rend = 3;
			if (Have_MMX) *Blit = Blit_Scanline_MMX;
			else *Blit = Blit_Scanline;
			MESSAGE_L("Render selected : FULL SCANLINE", "Render selected : FULL SCANLINE", 1500)
			break;

		case 4:
			if (Have_MMX)
			{
				*Rend = 4;
				*Blit = Blit_Scanline_50_MMX;
				MESSAGE_L("Render selected : 50% SCANLINE", "Render selected : 50% SCANLINE", 1500)
			}
			else
			{
				*Rend = 6;
				*Blit = Blit_Scanline_Int;
				MESSAGE_L("Render selected : INTERPOLATED SCANLINE", "Render selected : INTERPOLATED SCANLINE", 1500)
			}
			break;

		case 5:
			if (Have_MMX)
			{
				*Rend = 5;
				*Blit = Blit_Scanline_25_MMX;
				MESSAGE_L("Render selected : 25% SCANLINE", "Render selected : 25% SCANLINE", 1500)
			}
			else
			{
				*Rend = 3;
				*Blit = Blit_Scanline;
				MESSAGE_L("Render selected : FULL SCANLINE", "Render selected : FULL SCANLINE", 1500)
			}
			break;

		case 6:
			*Rend = 6;
			if (Have_MMX) *Blit = Blit_Scanline_Int_MMX;
			else *Blit = Blit_Scanline_Int;
			MESSAGE_L("Render selected : INTERPOLATED SCANLINE", "Render selected : INTERPOLATED SCANLINE", 1500)
			break;

		case 7:
			if (Have_MMX)
			{
				*Rend = 7;
				*Blit = Blit_Scanline_50_Int_MMX;
				MESSAGE_L("Render selected : INTERPOLATED 50% SCANLINE", "Render selected : INTERPOLATED 50% SCANLINE", 1500)
			}
			else
			{
				*Rend = 6;
				*Blit = Blit_Scanline_Int;
				MESSAGE_L("Render selected : INTERPOLATED SCANLINE", "Render selected : INTERPOLATED SCANLINE", 1500)
			}
			break;

		case 8:
			if (Have_MMX)
			{
				*Rend = 8;
				*Blit = Blit_Scanline_25_Int_MMX;
				MESSAGE_L("Render selected : INTERPOLATED 25% SCANLINE", "Render selected : INTERPOLATED 25% SCANLINE", 1500)
			}
			else
			{
				*Rend = 6;
				*Blit = Blit_Scanline_Int;
				MESSAGE_L("Render selected : INTERPOLATED SCANLINE", "Render selected : INTERPOLATED SCANLINE", 1500)
			}
			break;

		case 9:
			if (Have_MMX)
			{
				*Rend = 9;
				*Blit = Blit_2xSAI_MMX;
				MESSAGE_L("Render selected : 2XSAI KREED'S ENGINE", "Render selected : 2XSAI KREED'S ENGINE", 1500)
			}
			else
			{
				*Rend = 6;
				*Blit = Blit_Scanline_Int;
				MESSAGE_L("Render selected : INTERPOLATED SCANLINE", "Render selected : INTERPOLATED SCANLINE", 1500)
			}
			break;

		default:
			*Rend = 1;
			if (Have_MMX) *Blit = Blit_X2_MMX;
			else *Blit = Blit_X2;
			MESSAGE_L("Render selected : DOUBLE", "Render selected : DOUBLE", 1500)
			break;
	}

	// Mode fentr ou Mode Force ou Num<2 ou Old_rend < 2
	
	//if (!((Full == Full_Screen) && ((Num >=2) && (Old_Rend >= 2)) && (!Force) ))
	{
        //Modif IM - move window back to original location when changing rendering mode
        //XXX: if you can get XGetWindowAttributes to do its job, you should save the x,y here
        int retval;
		End_DDraw();

		if (Sound_Initialised) Clear_Sound_Buffer();

		if ((Full_Screen = Full))
		{
			retval = Init_DDraw(HWnd, /*320 * ((*Rend == 0)?1:2)*/640,/*240 * ((*Rend == 0)?1:2)*/480,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
		}
		else
		{
			retval = Init_DDraw(HWnd, 320 * ((*Rend == 0)?1:2),240 * ((*Rend == 0)?1:2),SDL_HWSURFACE|SDL_DOUBLEBUF);
		}

        //Modif IM - move window back to original location when changing rendering modes
        if (swi_init)
        {
            XWindowChanges changes;
            changes.x = WindowX;
            changes.y = WindowY;
            SDL_GetWMInfo(&swi); 
            XConfigureWindow(swi.info.x11.display,swi.info.x11.wmwindow,CWX|CWY,&changes);
        }
        return retval;
            
	}
}

unsigned long GetTickCount()
{
	return gettime();
}

void Sleep(int i)
{
	struct timespec rqtp = {0,i};
	// i : millisecond
	//usleep(1000*i);
	rqtp.tv_nsec *= 1000000;
	nanosleep(&rqtp, NULL);
}

void save_state()
{
	Str_Tmp[0] = 0;
	Get_State_File_Name(Str_Tmp);
	Save_State(Str_Tmp);
}

void load_state()
{
	Str_Tmp[0] = 0;
	Get_State_File_Name(Str_Tmp);
	Load_State(Str_Tmp);
}

void system_reset()
{
	if (Genesis_Started)
	{
		Reset_Genesis();
	}
	else if (_32X_Started)
	{
		Reset_32X();
	}
	else if (SegaCD_Started)
	{
		Reset_SegaCD();
	}
    MainMovie.MovieStatus = 0;
}

void update_ui_events()
{

  char* tmp_str;
  int len;
  static int PrevFrameSkip = 0; //Modif IM - save/restore frame skip when fast-forwarding
  static int PrevSoundEnable = 0; //Modif IM - same for sound



  while(SDL_PollEvent(&event)) {

	switch(event.type)
	{
	/*
		case SDL_VIDEORESIZE:
			surface = SDL_SetVideoMode(event.resize.w, event.resize.h, 16, SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_RESIZABLE);
			break;
	*/
        //Modif IM - quit when close box is clicked
        case SDL_QUIT:
            if (Sound_Initialised) Clear_Sound_Buffer(); //Modif N - make sound not stutter on exit
            if(MainMovie.MovieStatus!=0)
                CloseMovieFile(&MainMovie);
            Gens_Running = 0;
            break;

		case SDL_KEYDOWN:
			key[event.key.keysym.sym] = 1;
            //ignore numlock, caps lock, mode
            event.key.keysym.mod = (SDLMod)(event.key.keysym.mod & (0xFFFF ^ ignore_mods));


            /*printf("looking for: ");
            print_SDLK(&RAM_Search_Menu_key);
            printf("found      : ");
            print_SDLK(&event.key.keysym);
            printf("\n"); 
            if (IsPressed(&RAM_Search_Menu_key))
                printf("YAY!\n");
            if (IsPressed(&Start_Recording_key))
                printf("whoops!\n"); // */
            
            //Modif IM - switch->if/else needed to make these keys configurable
            //Pause Emulator
            if (IsPressed(&Pause_Emulator_key))
            {
#ifdef WITH_GTK
                if (Debug)
                {
                    Change_Debug(HWnd, 0);
                    Paused = 0;						
                }
                else if (Paused)
                {
                    Paused = 0;
                }
                else
                {
                    Paused = 1;
                    Pause_Screen();
                    Clear_Sound_Buffer();
                }
#else
                if (Paused)
                {
                    Paused = 0;
                }
                else
                {
                    Paused = 1;
                    Pause_Screen();
                    Clear_Sound_Buffer();
                }
            //Quit
            //Modif IM: made escape kay pause like normal and exit with shift
            } 
            else if (IsPressed(&Quit_key))
            {
                if (Sound_Initialised) Clear_Sound_Buffer(); //Modif N - make sound not stutter on exit
                if(MainMovie.MovieStatus!=0)
                    CloseMovieFile(&MainMovie);
                Gens_Running = 0;
            }
#endif					
                
            //Take Screenshot
            else if (IsPressed(&Take_Screenshot_key))
            {
                Clear_Sound_Buffer();
                Take_Shot();
            }
            //XXX: should make code nicer
            else if (IsPressed(&Fast_Forward_key))
            {
                if (Frame_Skip != 16)
                {
                    PrevFrameSkip = Frame_Skip;
                    //disable sound so it doesn't slow down emulator
                    PrevSoundEnable = Sound_Enable;
                    End_Sound();
                    Sound_Enable = 0;
                    Set_Frame_Skip(HWnd, 16);
                }
                else
                {
                    Set_Frame_Skip(HWnd, PrevFrameSkip);
                    Sound_Enable = PrevSoundEnable;
                    if (Sound_Enable)
                    {
                        Init_Sound(HWnd);
                        Play_Sound();
                    }
                }
            
            }
            else if (IsPressed(&Reset_key))
            {
                FrameCount = 0;
                if (MainMovie.MovieStatus)
                    Put_Info("Movie stopped for reset.",1500);
                system_reset();
            }
            else if (IsPressed(&Lower_Speed_key))
            {
                if(--SpeedChangeFactor < -5)
                    SpeedChangeFactor = -5;
                sprintf(Str_Tmp,"lowered speed to %.0f%%\n",100.0/pow(2,-SpeedChangeFactor));
                Put_Info(Str_Tmp,1500);
                SpeedChangeEnabled = (SpeedChangeFactor != 0);
            }
            else if (IsPressed(&Raise_Speed_key))
            {
                if (++SpeedChangeFactor > 0)
                    SpeedChangeFactor = 0;
                sprintf(Str_Tmp,"raised speed to %.0f%%\n",100.0/pow(2,-SpeedChangeFactor));
                Put_Info(Str_Tmp,1500);
                SpeedChangeEnabled = (SpeedChangeFactor != 0);
            }
            //XXX: b0rk3n
            else if (IsPressed(&Toggle_Fullscreen_key))
            {
                if (Full_Screen) Set_Render(HWnd, 0, -1, true);
                else Set_Render(HWnd, 1, Render_FS, true);
            }
            else if (IsPressed(&Auto_Frameskip_key))					
            {
                Set_Frame_Skip(HWnd, -1);
                sync_gens_ui();
            }
            else if (IsPressed(&Change_Stretch_key))
            {
                Change_Stretch();
                sync_gens_ui();
            }
            else if (IsPressed(&Change_Vsync_key))
            {
                Change_VSync(HWnd);
                sync_gens_ui();
            }
            else if (IsPressed(&Lower_Frameskip_key))
            {
                if (Frame_Skip == -1)
                {
                    Set_Frame_Skip(HWnd, 0);
                    sync_gens_ui();
                }
                else
                {
                    if (Frame_Skip > 0)
                    {
                        Set_Frame_Skip(HWnd, Frame_Skip - 1);
                        sync_gens_ui();
                    }
                }
            }
            else if (IsPressed(&Raise_Frameskip_key))
            {
                if (Frame_Skip == -1)
                {
                    Set_Frame_Skip(HWnd, 1);
                    sync_gens_ui();
                }
                else
                {
                    if (Frame_Skip < 8) Set_Frame_Skip(HWnd, Frame_Skip + 1);
                    sync_gens_ui();
                }
                
            }
            else if (IsPressed(&Save_Current_State_key) || IsPressed(&Alt_Save_Current_State_key))
            {
                Str_Tmp[0] = 0;
                Get_State_File_Name(Str_Tmp);
                Save_State(Str_Tmp);					
            }
            //XXX: saving to a file not implemented in non-gui version
            else if (IsPressed(&Load_State_File_key))
            {
                //if (Check_If_Kaillera_Running()) return 0;
                CLI_FOCUS;
                tmp_str = readline("name of state to load:");
                Load_State(tmp_str);
                free(tmp_str);
                WINDOW_FOCUS;
            }
            else if (IsPressed(&Save_State_File_key))
            {
                //if (Check_If_Kaillera_Running()) return 0;
                CLI_FOCUS;
                tmp_str = readline("name of state to save:");
                Save_State(tmp_str);
                free(tmp_str);
                WINDOW_FOCUS;
            }
            else if (IsPressed(&Select_Previous_State_key))
            {
                Set_Current_State(0, (Current_State + 9) % 10);
                sync_gens_ui();
            }
            else if (IsPressed(&Select_Next_State_key))
            {
                Set_Current_State(0, (Current_State + 1) % 10);
                sync_gens_ui();
            }
            else if (IsPressed(&Load_Current_State_key) || IsPressed(&Alt_Load_Current_State_key))
            {
                //if (Check_If_Kaillera_Running()) return 0;
                Get_State_File_Name(Str_Tmp);
                Load_State(Str_Tmp);
            
            }
            else if (IsPressed(&Change_Blit_Style_key))
            {
                Change_Blit_Style();
            }
            else if (IsPressed(&Toggle_Fast_Blur_key))
            {
                Change_Fast_Blur(HWnd);
            }
            else if (IsPressed(&Toggle_Improved_DAC_key))
            {
                Change_DAC_Improv(HWnd);
                sync_gens_ui();
            }
            else if (IsPressed(&Toggle_FPS_Display_key))
            {
                Show_FPS = !Show_FPS;
            }
            else if (IsPressed(&Toggle_Improved_PSG_key))	
            {
                Change_PSG_Improv(HWnd);
                sync_gens_ui();
            }
            else if (IsPressed(&Previous_Rendering_Mode_key))
            {
                if ((Full_Screen) && (Render_FS > 0))
                {
                    Set_Render(HWnd, 1, Render_FS - 1, false);
                    sync_gens_ui();
                }
                else if ((!Full_Screen) && (Render_W > 0))
                {
                    Set_Render(HWnd, 0, Render_W - 1, false);
                    sync_gens_ui();
                }
            }
            else if (IsPressed(&Toggle_Improved_YM2612_key))	
            {
                Change_YM2612_Improv(HWnd);
                sync_gens_ui();
            }
            else if (IsPressed(&Next_Rendering_Mode_key))
            {
                if ((Full_Screen) && (Render_FS < 9))
                {
                    Set_Render(HWnd, 1, Render_FS + 1, false);
                    sync_gens_ui();
                }
                else if ((!Full_Screen) && (Render_W < 9))
                {
                    Set_Render(HWnd, 0, Render_W + 1, false);
                    sync_gens_ui();
                }
            }						
            else if (IsPressed(&Select_State_0_key))
            {
                    Set_Current_State(HWnd, 0);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_1_key))
            {
                    Set_Current_State(HWnd, 1);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_2_key))
            {
                    Set_Current_State(HWnd, 2);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_3_key))
            {
                    Set_Current_State(HWnd, 3);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_4_key))
            {
                    Set_Current_State(HWnd, 4);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_5_key))
            {
                    Set_Current_State(HWnd, 5);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_6_key))
            {
                    Set_Current_State(HWnd, 6);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_7_key))
            {
                    Set_Current_State(HWnd, 7);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_8_key))
            {
                    Set_Current_State(HWnd, 8);
                    sync_gens_ui();
            }
            else if (IsPressed(&Select_State_9_key))
            {
                    Set_Current_State(HWnd, 9);
                    sync_gens_ui();
            }
            else if (IsPressed(&Load_State_0_key))
            {
                    Set_Current_State(HWnd, 0);
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
                    sync_gens_ui();
            }
            else if (IsPressed(&Load_State_1_key))
            {
                    Set_Current_State(HWnd, 1);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_2_key))
            {
                    Set_Current_State(HWnd, 2);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_3_key))
            {
                    Set_Current_State(HWnd, 3);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_4_key))
            {
                    Set_Current_State(HWnd, 4);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_5_key))
            {
                    Set_Current_State(HWnd, 5);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_6_key))
            {
                    Set_Current_State(HWnd, 6);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_7_key))
            {
                    Set_Current_State(HWnd, 7);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_8_key))
            {
                    Set_Current_State(HWnd, 8);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Load_State_9_key))
            {
                    Set_Current_State(HWnd, 9);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Load_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_0_key))
            {
                    Set_Current_State(HWnd, 0);
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
                    sync_gens_ui();
            }
            else if (IsPressed(&Save_State_1_key))
            {
                    Set_Current_State(HWnd, 1);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_2_key))
            {
                    Set_Current_State(HWnd, 2);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_3_key))
            {
                    Set_Current_State(HWnd, 3);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_4_key))
            {
                    Set_Current_State(HWnd, 4);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_5_key))
            {
                    Set_Current_State(HWnd, 5);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_6_key))
            {
                    Set_Current_State(HWnd, 6);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_7_key))
            {
                    Set_Current_State(HWnd, 7);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_8_key))
            {
                    Set_Current_State(HWnd, 8);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }
            else if (IsPressed(&Save_State_9_key))
            {
                    Set_Current_State(HWnd, 9);
                    sync_gens_ui();
                    Get_State_File_Name(Str_Tmp);
                    Save_State(Str_Tmp);
            }

            /*else if (event.key.keysym.sym == SDLK_b)
            {
                if (KMOD_CTRL & event.key.keysym.mod)
                {
                    if (Num_CD_Drive == 0) return ;// return 1;
                    //if (Check_If_Kaillera_Running()) return 0;
                    if (GYM_Playing) Stop_Play_GYM();
                    Free_Rom(Game);			// Don't forget it !
                    SegaCD_Started = Init_SegaCD(NULL);						
                }
                
            }*/
            //Close ROM
            else if (IsPressed(&Close_ROM_key))
            {
                if (Sound_Initialised) Clear_Sound_Buffer();
                Debug = 0;
                if (Net_Play)
                {
                    if (Full_Screen) Set_Render(HWnd, 0, -1, true);
                    sync_gens_ui();
                }
                Free_Rom(Game);						
            }
            //XXX: need to rework for non-gui version
            else if (IsPressed(&Open_Game_Genie_key))
            {
                //if (Check_If_Kaillera_Running()) return 0;						
                MINIMIZE;
                open_game_genie();						
            }
            else if (IsPressed(&Change_SegaCD_Syncro_key))
            {
                Change_SegaCD_Synchro();
                sync_gens_ui();
            }
            //XXX: check that this still works
            else if (IsPressed(&Start_Playing_GYM_key))
            {
                if (!Genesis_Started && !SegaCD_Started && !_32X_Started)
                {
                    if (GYM_Playing) Stop_Play_GYM();
                    else Start_Play_GYM();
                    sync_gens_ui();
                }						
            }
            else if (IsPressed(&Change_CD_key))
            {
                if (KMOD_CTRL & event.key.keysym.mod)
                    if (SegaCD_Started) Change_CD();
            }
            else if (IsPressed(&Toggle_WAV_Dumping_key))
            {
                if (WAV_Dumping) Stop_WAV_Dump();
                else Start_WAV_Dump();
                sync_gens_ui();
            }
            else if (IsPressed(&Start_Recording_key))
            {
                if(!(Game)) //if no game has been loaded
                {
                    //return 0;
                }
                else if(MainMovie.MovieStatus!=MOVIE_PLAYING)
                {
                    Put_Info("Error: no movie is playing", 1500);
                }
                else if(MainMovie.ReadOnly)
                {
                    Put_Info("Error: movie is read only", 1500);
                }
                else
                {
                    strncpy(Str_Tmp,MainMovie.FileName,512);
                    if(AutoBackupEnabled)                     
                    {
                        strcat(MainMovie.FileName,".gmv");
                        MainMovie.FileName[strlen(MainMovie.FileName)-7]='b';
                        MainMovie.FileName[strlen(MainMovie.FileName)-6]='a';
                        MainMovie.FileName[strlen(MainMovie.FileName)-5]='k';
                        BackupMovieFile(&MainMovie);
                        strncpy(MainMovie.FileName,Str_Tmp,512);
                        printf("movie backed up!\n");
                    }
                    else
                        printf("backup disabled\n");
                    MainMovie.MovieStatus=MOVIE_RECORDING;
                    MainMovie.NbRerecords++;
                    MainMovie.LastFrame=FrameCount;
                    Put_Info("Recording from current frame", 1500);
                }
            }
            else if (IsPressed(&RAM_Search_Menu_key))
            {
                CLI_FOCUS;
                RAM_Search_Menu();
                WINDOW_FOCUS;
            }
            else if (IsPressed(&Toggle_Readonly_key))
            {
                MainMovie.ReadOnly = !MainMovie.ReadOnly;
                if(MainMovie.MovieStatus!=0)
                {
                    if(MainMovie.ReadOnly)
                        Put_Info("Movie is now read-only.", 1500);
                    else
                        Put_Info("Movie is now editable.", 1500);
                }
                else
                {
                    Put_Info("Can't toggle read-only; no movie is active.", 1500);
                }
            }
            else if (IsPressed(&Play_Movie_key)) //Modif N/IM - play movie
            {
                CLI_FOCUS;
                tmp_str = readline("movie filename:");
                len = strlen(tmp_str);
                if(tmp_str[len-1] == ' ')
                    tmp_str[len-1] = 0;
                PlayMovie(tmp_str,"");
                free(tmp_str);
                WINDOW_FOCUS;
                
			}
            //Advance Frame
            else if (IsPressed(&Advance_Frame_key))
            {
                Paused = 1;
                FrameAdvanceEnabled = 1;
            }
            //Toggle Frame Counter
            else if (IsPressed(&Toggle_Frame_Counter_key))
            {
                if (FrameCounterEnabled)
                    Put_Info("Frame counter disabled.",1500);
                else
                    Put_Info("Frame counter enabled.",1500);

                FrameCounterEnabled = !FrameCounterEnabled;
            }
            //Toggle Input Display
            else if (IsPressed(&Toggle_Input_Display_key))
            {
                if (ShowInputEnabled)
                    Put_Info("Input display disabled.",1500);
                else
                    Put_Info("Input display enabled.",1500);

                ShowInputEnabled = 1 - ShowInputEnabled;
            }
            //Toggle Sound
            else if (IsPressed(&Toggle_Sound_key))
            {
                Change_Sound(HWnd);
            }
            else if (IsPressed(&Stop_Movie_key))
            {
                if (MainMovie.MovieStatus == MOVIE_RECORDING)
                {
                    CloseMovieFile(&MainMovie);
                    Put_Info("Movie recording stopped.",1500);
                }
                else if (MainMovie.MovieStatus == MOVIE_PLAYING)
                {
                    CloseMovieFile(&MainMovie);
                    Put_Info("Movie playing stopped.",1500);
                }
                MainMovie.MovieStatus = 0;
            }
            //Record New Movie
            else if (IsPressed(&Record_New_Movie_key))
            {
                CLI_FOCUS;
                NewMovieMenu();
                WINDOW_FOCUS;
            }
            else if (IsPressed(&Save_Config_File_key))
            {
                strcpy(Str_Tmp, Gens_Path);
                strcat(Str_Tmp, "gens.cfg");
                Save_Config(Str_Tmp);  
                Put_Info("config file saved",1500);
            }
		case SDL_KEYUP:
			key[event.key.keysym.sym] = 0;
			break;
		default:
			break;
	}
  }
}

void update_joysticks()
{
    if(!use_joystick) return;
	if (SDL_NumJoysticks())
	{
		SDL_JoystickUpdate();
		for (int c = 0; c < SDL_JoystickNumButtons(joy[0]); c++)
			input_set_joy_down(c, SDL_JoystickGetButton(joy[0],c));
		input_set_joy_motion(
			(SDL_JoystickGetAxis(joy[0], 1) > 0 ? 0x0001:0x0010)
		|   (SDL_JoystickGetAxis(joy[0], 0) < 0 ? 0x0100:0x1000)
		,0);
	}		
}


void update_events()
{
	update_ui_events();
	update_joysticks();
}

void close_gens()
{
	Gens_Running = 0;
}

bool Init(int hInst, int nCmdShow)
{

  if (SDL_Init(SDL_INIT_TIMER|SDL_INIT_VIDEO|SDL_INIT_JOYSTICK) <0) return false;
  init_timer();

  Net_Play = 0;
  Full_Screen = -1;
  VDP_Num_Vis_Lines = 224;
  Resolution = 1;
  W_VSync = 0;
  FS_VSync = 0;
  Stretch = 0;
  Sprite_Over = 1;
  Render_W = 0;
  Render_FS = 0;
  Show_Message = 1;

  Sound_Enable = 0;
  Sound_Segs = 8;
  Sound_Stereo = 1;
  Sound_Initialised = 0;
  Sound_Is_Playing = 0;
  WAV_Dumping = 0;
  GYM_Dumping = 0;

  FS_Minimised = 0;
  Game = NULL;
  Genesis_Started = 0;
  SegaCD_Started = 0;
  _32X_Started = 0;
  Debug = 0;
  CPU_Mode = 0;
	
  Identify_CPU();
	
  GetCurrentDirectory(1024, Gens_Path);
  GetCurrentDirectory(1024, Language_Path);
  GetCurrentDirectory(1024, Str_Tmp);
  strcpy(Manual_Path, "");
  strcpy(CGOffline_Path, "");
  
  strcat(Gens_Path, "/");
  strcat(Language_Path, "/language.dat");
  strcat(Str_Tmp, "/gens.cfg");

  Build_Language_String();

  MSH2_Init();
  SSH2_Init();
  M68K_Init();
  S68K_Init();
  Z80_Init();

  YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
  PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
  PWM_Init();

  Load_Config(Str_Tmp, NULL);
  Init_Input(0, 0);
	
  Init_CD_Driver();
  Init_Tab();
  Gens_Running = 1;

  return true;
}

void End_All(void)
{
	Free_Rom(Game);
	End_DDraw();
	End_Input();
	YM2612_End();
	End_Sound();
	End_CD_Driver();
    if (MainMovie.MovieStatus != 0) //Modif N/IM
        CloseMovieFile(&MainMovie);
	SDL_JoystickClose(joy[0]);
	SDL_Quit();
}

HMENU Build_Main_Menu(void)
{
	return(Gens_Menu);
}

void get_video_size(int render, int &w, int &h)
{
	if(render > 0) {
		w = 640;
		h = 480;
	}
}

void init_directories()
{
	/*strcpy(JA_CD_Bios, "jp_mcd1_9112.bin");
	strcpy(US_CD_Bios, "us_scd1_9210.bin");
	strcpy(EU_CD_Bios, "eu_mcd1_9210.bin");
	strcpy(_32X_Genesis_Bios, "32X_G_BIOS.BIN");
	strcpy(_32X_Master_Bios, "32X_M_BIOS.BIN");
	strcpy(_32X_Slave_Bios, "32X_S_BIOS.BIN");*/
	/*strcpy(State_Dir, "./state/");
	strcpy(SRAM_Dir, "./sram/");
	strcpy(BRAM_Dir, "./bram/");
	strcpy(Patch_Dir, "./patch/");*/
}

void open_joystick()
{
	joy[0] = SDL_JoystickOpen(0);
}

int main(int argc, char *argv[])
{
	Init_Genesis_Bios();

#ifdef WITH_GTK
	add_pixmap_directory("./resource/");
	gtk_init(&argc, &argv);
	gens_window = create_gens_window();
	gtk_widget_show_all(gens_window);
	

	if(!Init(0, 0)) return 0;
	init_directories();
	sync_gens_ui();
	
#else
	int w,h,flags;
    MainMovie.FileName[0] = 0;
	if(argc <= 1) {
		printf("Gens 2.12a (Genesis/32x emulator) by Stephane Dallongeville,\n");
        printf("BeOS port by Caz,\n");
        printf("FreeBSD port by Stephane Akhoun\n");
        printf("misc fixes/changes by IdeaMagnate\n\n");
		printf("Gens Homepage: http://gens.consolemul.com/\n");
		printf("Using SDL: http://libsdl.org\n");
		printf("usage: %s <filename> [options]\n\n", argv[0]);
		printf("options:\n");
		printf("\t-s\tEnable Sound.\n");
		printf("\t-g\tGraphics Mode number. e.g -g 2\n");
		printf("\t-f\tFullscreen.\n");
		printf("\t-j\tJoystick.\n");
		printf("\t-v\tVsync.\n");
		printf("\t-m\tmovie.gmv\n");
		printf("\t-t\tstate.gst\n");
		printf("\t-r\tramview.grv\n");
		return 1;
	}
	if(!Exists(argv[1])) {
		printf("%s does not exist\n", argv[1]);
		return 1;
	}
	
	if(!Init(0, 0)) return 0;
	init_directories();
    MainMovie.StateName[0] = 0;

	for(int i = 0; (i < argc || argv[i] != NULL); i++)
	{
		if(!strcmp(argv[i], "-s")) Sound_Enable = 1;
		if(!strcmp(argv[i], "-g"))
		{
			if(argv[i + 1] != 0)
			{
				Render_W = atoi(argv[++i]);
				get_video_size(Render_W, w, h);
			}
		}
		if(!strcmp(argv[i], "-f"))
		{
			w = 640, h = 480, flags = SDL_FULLSCREEN;
		}
		if(!strcmp(argv[i], "-j")) { open_joystick(); use_joystick = true; }
		if(!strcmp(argv[i], "-v")) W_VSync = 1;
		if(!strcmp(argv[i], "-m")) 
        { 
           if(i == argc)
           {
               fprintf(stderr,"Please specify a movie file.\n");
               exit(1);
           }
           else if(!Exists(argv[i+1]) )
           {
               fprintf(stderr,"Couldn't find %s\n",argv[i+1]);
               exit(1);
           }
           else
           {
               strncpy(MainMovie.FileName,argv[i+1],1023);
               PlayCLIMovie = 1;
           }
           i++;
        }
		if(!strcmp(argv[i], "-t")) 
        { 
           if(i == argc)
           {
               fprintf(stderr,"Please specify a save state.\n");
               exit(1);
           }
           else if(!Exists(argv[i+1]) )
           {
               fprintf(stderr,"Couldn't find %s\n",argv[i+1]);
               exit(1);
           }
           else
               strncpy(MainMovie.StateName,argv[i+1],1023);
           i++;
        }
		if(!strcmp(argv[i], "-r"))
        {
            if (!read_ramview_file(argv[i+1]))
            {
                fprintf(stderr,"couldn't open ramview file\n");
                exit(1);
            }
            else
            {
                i++;
            }
        }
	}

	Gens_Running = Get_Rom(0, argv[1]);

    SDL_VERSION(&swi.version); //Modif IM - convenient focus stuff
    SDL_GetWMInfo(&swi); 
    swi_init = 1;
    XWindowChanges changes; //Modif IM - move window to configured location
    changes.x = WindowX;
    changes.y = WindowY;
    XConfigureWindow(swi.info.x11.display,swi.info.x11.wmwindow,CWX|CWY,&changes);

    /*char str[32];
    strcpy(str,"c-backspace");
    SDL_keysym ks;
    ascii2SDLK(str,&ks);
    printf("\"%s\" translates to %d w/ mod ",str,ks.sym);
    if( ks.mod & KMOD_NUM )    printf( "NUMLOCK," );
    if( ks.mod & KMOD_CAPS )   printf( "CAPSLOCK," );
    if( ks.mod & KMOD_CTRL )   printf( "CTRL," );
    if( ks.mod & KMOD_SHIFT )  printf( "SHIFT," );
    if( ks.mod & KMOD_ALT )    printf( "ALT," );
    if( ks.mod & KMOD_META )   printf( "META," );
    printf( "\n" );
    SDLK2ascii(str,&ks);
    printf("key translates back to %s\n",str); 
    SDLK2ascii(str,&RAM_Search_Menu_key);
    printf("ram search key is %s\n",str); // */
	
#endif
	while (Gens_Running)
	{
		update_events();
#ifdef WITH_GTK
		while (gtk_events_pending())
			gtk_main_iteration_do(0);
#endif
#ifdef GENS_DEBUG
		if (Debug)						// DEBUG
		{
			Update_Debug_Screen();
			Flip(HWnd);
		}
		else
#endif
        //Modif IM - hack to play movies from the cli
        if (PlayCLIMovie)
        {
            strncpy(Str_Tmp,MainMovie.FileName,1023);
            if (MainMovie.StateName[0] != 0)
                PlayMovie(Str_Tmp,MainMovie.StateName);
            else 
                PlayMovie(Str_Tmp,"");
            PlayCLIMovie = 0;
        }
		if (Genesis_Started || _32X_Started || SegaCD_Started)
		{
			if ((Active) && (!Paused))	// EMULATION
			{
				
                Update_Emulation(HWnd);
			}
            else if (FrameAdvanceEnabled)// EMULATION PAUSED
            {
                Update_Emulation_One(HWnd);
                FrameAdvanceEnabled = 0;
            }
			else						
			{
				Flip(HWnd);
				Sleep(100);
			}
            Clear_Sound_Buffer();
		}
		else if (GYM_Playing)			// PLAY GYM
		{
			Play_GYM();
			Update_Gens_Logo(HWnd);
		}
		else if (Intro_Style == 1)		// GENS LOGO EFFECT
		{
			Update_Gens_Logo(HWnd);
			Sleep(5);
		}
		else if (Intro_Style == 2)		// STRANGE EFFECT
		{
			Update_Crazy_Effect(HWnd);
			Sleep(10);
		}
		else if (Intro_Style == 3)		// GENESIS BIOS
		{
			Do_Genesis_Frame();
			Flip(HWnd);
			Sleep(20);
		}
		else							// BLANK SCREEN (MAX IDLE)
		{
			//Clear_Back_Screen(HWnd);
			Flip(HWnd);
			Sleep(200);
		}
	}

    End_Sound();  //Modif N/IM - no stuttering on exit

	/*strcpy(Str_Tmp, Gens_Path);
	strcat(Str_Tmp, "gens.cfg");
	Save_Config(Str_Tmp);  //Modif IM - I'll save my changes when I feel like it.*/
    //free_ramview_comments();  //Modif IM - ram search stuff

	End_All();
	return 0;
}

int Set_Frame_Skip(HWND hWnd, int Num)
{
	Frame_Skip = Num;

	if (Frame_Skip != -1)
		MESSAGE_NUM_L("Frame skip set to %d", "Frame skip set to %d", Frame_Skip, 1500)
	else
		MESSAGE_L("Frame skip set to Auto", "Frame skip set to Auto", 1500)

	return(1);
}

int Set_Current_State(HWND hWnd, int Num)
{
	FILE *f;
	
	Current_State = Num;

	if ((f = Get_State_File()))
	{
		fclose(f);
		MESSAGE_NUM_L("SLOT %d [OCCUPIED]", "SLOT %d [OCCUPIED]", Current_State, 1500)
	}
	else
	{
		MESSAGE_NUM_L("SLOT %d [EMPTY]", "SLOT %d [EMPTY]", Current_State, 1500)
	}

	Build_Main_Menu();
	return 1;
}


int Build_Language_String(void)
{
	unsigned long nb_lue = 1;
	int sec_alloue = 1, poscar = 0;
	enum etat_sec {DEB_LIGNE, SECTION, NORMAL} etat = DEB_LIGNE;

#ifdef __PORT__
	FILE* LFile;
#else	
	HANDLE LFile;
#endif
	
	char c;

	if (language_name)
	{
		free(language_name);
		language_name = NULL;
	}

	language_name = (char**)malloc(sec_alloue * sizeof(char*));
	language_name[0] = NULL;

#ifdef __PORT__
	LFile = fopen(Language_Path, "r");
	if (!LFile)
	{
		LFile = fopen(Language_Path, "w");
	}
#else
	LFile = CreateFile(Language_Path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
#endif
	
	while(nb_lue)
	{
	
#ifdef __PORT__	
	nb_lue = fread(&c,1,1,LFile);
#else
	ReadFile(LFile, &c, 1, &nb_lue, NULL);
#endif
		switch(etat)
		{
			case DEB_LIGNE:
				switch(c)
				{
					case '[':
						etat = SECTION;
						sec_alloue++;
						language_name = (char**)realloc(language_name, sec_alloue * sizeof(char*));
						language_name[sec_alloue - 2] = (char*)malloc(32 * sizeof(char));
						language_name[sec_alloue - 1] = NULL;
						poscar = 0;
						break;

					case '\n':
						break;

					default: etat = NORMAL;
						break;
				}
				break;

			case NORMAL:
				switch(c)
				{
					case '\n':
						etat = DEB_LIGNE;
						break;

					default:
						break;
				}
				break;

			case SECTION:
				switch(c)
				{
					case ']':
						language_name[sec_alloue - 2][poscar] = 0;
						etat = DEB_LIGNE;
						break;

					default:
						if(poscar < 32)
							language_name[sec_alloue - 2][poscar++] = c;
						break;
				}
				break;
		}
	}
#ifdef __PORT__
	fclose(LFile);
#else
	CloseHandle(LFile);
#endif
	if (sec_alloue == 1)
	{
		language_name = (char**)realloc(language_name, 2 * sizeof(char*));
		language_name[0] = (char*)malloc(32 * sizeof(char));
		strcpy(language_name[0], "English");
		language_name[1] = NULL;
		WritePrivateProfileString("English", "Menu Language", "&English menu", Language_Path);
	}

	return(0);	
}


int Change_VSync(HWND hWnd)
{
	int *p_vsync;
	
	if (Full_Screen)
	{
		End_DDraw();
		p_vsync = &FS_VSync;
	}
	else p_vsync = &W_VSync;
	
	*p_vsync = 1 - *p_vsync;
	
	if (*p_vsync) MESSAGE_L("Vertical Sync Enabled", "Vertical Sync Enabled", 1000)
	else MESSAGE_L("Vertical Sync Disabled", "Vertical Sync Disabled", 1000)

	if (Full_Screen) return Init_DDraw(HWnd, 640,480, SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
	else return 1;
}


int Change_Stretch(void)
{
	if ((Full_Screen) && (Render_FS > 1)) return(0);
	
	Flag_Clr_Scr = 1;

	if ((Stretch = (1 - Stretch)))
		MESSAGE_L("Stretched mode", "Stretched mode", 1000)
	else
		MESSAGE_L("Correct ratio mode", "Correct ratio mode", 1000)

	return(1);
}


int Change_Blit_Style(void)
{
	if ((!Full_Screen) || (Render_FS > 1)) return(0);

	Flag_Clr_Scr = 1;

	if ((Blit_Soft = (1 - Blit_Soft)))
		MESSAGE_L("Force software blit for Full-Screen", "Force software blit for Full-Screen", 1000)
	else
		MESSAGE_L("Enable hardware blit for Full-Screen", "Enable hardware blit for Full-Screen", 1000)

	return(1);
}

int Set_Sprite_Over(HWND hWnd, int Num)
{
	if ((Sprite_Over = Num))
		MESSAGE_L("Sprite Limit Enabled", "Sprite Limit Enabled", 1000)
	else
		MESSAGE_L("Sprite Limit Disabled", "Sprite Limit Disabled", 1000)

	return(1);
}

int Change_Debug(HWND hWnd, int Debug_Mode)
{
	if (!Game) return 0;
		
	Flag_Clr_Scr = 1;
	Clear_Sound_Buffer();

	if (Debug_Mode == Debug) Debug = 0;
	else Debug = Debug_Mode;
	
	return 1;
}

int Change_Country(HWND hWnd, int Num)
{
	unsigned char Reg_1[0x200];

	Flag_Clr_Scr = 1;

	switch(Country = Num)
	{
		default:
		case -1:
			if (Genesis_Started || _32X_Started) Detect_Country_Genesis();
			else if (SegaCD_Started) Detect_Country_SegaCD();
			break;

		case 0:
			Game_Mode = 0;
			CPU_Mode = 0;
			break;

		case 1:
			Game_Mode = 1;
			CPU_Mode = 0;
			break;

		case 2:
			Game_Mode = 1;
			CPU_Mode = 1;
			break;

		case 3:
			Game_Mode = 0;
			CPU_Mode = 1;
			break;
	}

	if (CPU_Mode)
	{
		CPL_Z80 = Round_Double((((double) CLOCK_PAL / 15.0) / 50.0) / 312.0);
		CPL_M68K = Round_Double((((double) CLOCK_PAL / 7.0) / 50.0) / 312.0);
		CPL_MSH2 = Round_Double(((((((double) CLOCK_PAL / 7.0) * 3.0) / 50.0) / 312.0) * (double) MSH2_Speed) / 100.0);
		CPL_SSH2 = Round_Double(((((((double) CLOCK_PAL / 7.0) * 3.0) / 50.0) / 312.0) * (double) SSH2_Speed) / 100.0);

		VDP_Num_Lines = 312;
		VDP_Status |= 0x0001;
		_32X_VDP.Mode &= ~0x8000;

		CD_Access_Timer = 2080;
		Timer_Step = 136752;
	}
	else
	{
		CPL_Z80 = Round_Double((((double) CLOCK_NTSC / 15.0) / 60.0) / 262.0);
		CPL_M68K = Round_Double((((double) CLOCK_NTSC / 7.0) / 60.0) / 262.0);
		CPL_MSH2 = Round_Double(((((((double) CLOCK_NTSC / 7.0) * 3.0) / 60.0) / 262.0) * (double) MSH2_Speed) / 100.0);
		CPL_SSH2 = Round_Double(((((((double) CLOCK_NTSC / 7.0) * 3.0) / 60.0) / 262.0) * (double) SSH2_Speed) / 100.0);

		VDP_Num_Lines = 262;
		VDP_Status &= 0xFFFE;
		_32X_VDP.Mode |= 0x8000;

		CD_Access_Timer = 2096;
		Timer_Step = 135708;
	}

	if (Sound_Enable)
	{
		PSG_Save_State();
		YM2612_Save(Reg_1);

		End_Sound();
		Sound_Enable = 0;

		if (CPU_Mode)
		{
			YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_PAL / 15, Sound_Rate);
		}
		else
		{
			YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
		}

		if (SegaCD_Started) Set_Rate_PCM(Sound_Rate);
		YM2612_Restore(Reg_1);
		PSG_Restore_State();
		
		if(!Init_Sound(hWnd)) return(0);

		Sound_Enable = 1;
		Play_Sound();
	}

	if (Game_Mode)
	{
		if (CPU_Mode) MESSAGE_L("Europe system (50 FPS)", "Europe system (50 FPS)", 1500)
		else MESSAGE_L("USA system (60 FPS)", "USA system (60 FPS)", 1500)
	}
	else
	{
		if (CPU_Mode) MESSAGE_L("Japan system (50 FPS)", "Japan system (50 FPS)", 1500)
		else MESSAGE_L("Japan system (60 FPS)", "Japan system (60 FPS)", 1500)
	}

	if (Genesis_Started)
	{
		if ((CPU_Mode == 1) || (Game_Mode == 0))
			sprintf(Str_Tmp, "Gens - Megadrive : %s", Game->Rom_Name_W);
		else
			sprintf(Str_Tmp, "Gens - Genesis : %s", Game->Rom_Name_W);

		SetWindowText(HWnd, Str_Tmp);
	}
	else if (_32X_Started)
	{
		if (CPU_Mode == 1)
			sprintf(Str_Tmp, "Gens - 32X (PAL) : %s", Game->Rom_Name_W);
		else
			sprintf(Str_Tmp, "Gens - 32X (NTSC) : %s", Game->Rom_Name_W);

		SetWindowText(HWnd, Str_Tmp);
	}
	else if (SegaCD_Started)
	{
		if ((CPU_Mode == 1) || (Game_Mode == 0))
			sprintf(Str_Tmp, "Gens - MegaCD : %s", Rom_Name);
		else
			sprintf(Str_Tmp, "Gens - SegaCD : %s", Rom_Name);

		SetWindowText(HWnd, Str_Tmp);
	}

	return 1;
}


int Change_Country_Order(int Num)
{
	char c_str[4][4] = {"USA", "JAP", "EUR"};
	char str_w[128];
	int sav = Country_Order[Num];
		
	if (Num == 1) Country_Order[1] = Country_Order[0];
	else if (Num == 2)
	{
		Country_Order[2] = Country_Order[1];
		Country_Order[1] = Country_Order[0];
	}
	Country_Order[0] = sav;

	if (Country == -1) Change_Country(HWnd, -1);		// Update Country

	sprintf(str_w, "Country detec.order : %s %s %s", c_str[Country_Order[0]], c_str[Country_Order[1]], c_str[Country_Order[2]]);
	MESSAGE_L(str_w, str_w, 1500)

	return(1);
}
int Change_Z80(HWND hWnd)
{
	if (Z80_State & 1)
	{
		Z80_State &= ~1;
		MESSAGE_L("Z80 Disabled", "Z80 Disabled", 1000)
	}
	else
	{
		Z80_State |= 1;
		MESSAGE_L("Z80 Enabled", "Z80 Enabled", 1000)
	}

	return(1);
}

int	Change_Sound(HWND hWnd)
{
	if (Sound_Enable)
	{
		End_Sound();

		Sound_Enable = 0;
		YM2612_Enable = 0;
		PSG_Enable = 0;
		DAC_Enable = 0;
		PCM_Enable = 0;
		PWM_Enable = 0;
		CDDA_Enable = 0;

		MESSAGE_L("Sound Disabled", "Sound Disabled", 1500)
	}
	else
	{
		if (!Init_Sound(hWnd))
		{
			Sound_Enable = 0;
			YM2612_Enable = 0;
			PSG_Enable = 0;
			DAC_Enable = 0;
			PCM_Enable = 0;
			PWM_Enable = 0;
			CDDA_Enable = 0;

			return 0;
		}

		Sound_Enable = 1;
		Play_Sound();

		if (!(Z80_State & 1)) Change_Z80(hWnd);

		YM2612_Enable = 1;
		PSG_Enable = 1;
		DAC_Enable = 1;
		PCM_Enable = 1;
		PWM_Enable = 1;
		CDDA_Enable = 1;

		MESSAGE_L("Sound Enabled", "Sound Enabled", 1500)
	}

	return 1;
}

int Change_SegaCD_Synchro(void)
{
	if (SegaCD_Accurate)
	{
		SegaCD_Accurate = 0;

		if (SegaCD_Started)
		{
			Update_Frame = Do_SegaCD_Frame;
			Update_Frame_Fast = Do_SegaCD_Frame_No_VDP;
		}

		MESSAGE_L("SegaCD normal mode", "SegaCD normal mode", 1500)
	}
	else
	{
		SegaCD_Accurate = 1;

		if (SegaCD_Started)
		{
			Update_Frame = Do_SegaCD_Frame_Cycle_Accurate;
			Update_Frame_Fast = Do_SegaCD_Frame_No_VDP_Cycle_Accurate;
		}

		MESSAGE_L("SegaCD perfect synchro mode (SLOW)", "SegaCD perfect synchro mode (slower)", 1500)
	}

	return 1;
}
int Change_Sample_Rate(HWND hWnd, int Rate)
{
	unsigned char Reg_1[0x200];

	switch (Rate)
	{
	case 0:
		Sound_Rate = 11025;
		MESSAGE_L("Sound rate set to 11025", "Sound rate set to 11025", 2500)
		break;

	case 1:
		Sound_Rate = 22050;
		MESSAGE_L("Sound rate set to 22050", "Sound rate set to 22050", 2500)
		break;

	case 2:
		Sound_Rate = 44100;
		MESSAGE_L("Sound rate set to 44100", "Sound rate set to 44100", 2500)
		break;
	}

	if (Sound_Enable)
	{
		PSG_Save_State();
		YM2612_Save(Reg_1);

		End_Sound();
		Sound_Enable = 0;

		if (CPU_Mode)
		{
			YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_PAL / 15, Sound_Rate);
		}
		else
		{
			YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
		}

		if (SegaCD_Started) Set_Rate_PCM(Sound_Rate);
		YM2612_Restore(Reg_1);
		PSG_Restore_State();
		
		if(!Init_Sound(hWnd)) return(0);

		Sound_Enable = 1;
		Play_Sound();
	}
	
	return(1);
}


int Change_Sound_Stereo(HWND hWnd)
{
	unsigned char Reg_1[0x200];

	if (Sound_Stereo)
	{
		Sound_Stereo = 0;
		MESSAGE_L("Mono sound", "Mono sound", 1000)
	}
	else
	{
		Sound_Stereo = 1;
		MESSAGE_L("Stereo sound", "Stereo sound", 1000)
	}

	if (Sound_Enable)
	{
		PSG_Save_State();
		YM2612_Save(Reg_1);

		End_Sound();
		Sound_Enable = 0;

		if (CPU_Mode)
		{
			YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_PAL / 15, Sound_Rate);
		}
		else
		{
			YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
			PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
		}

		if (SegaCD_Started) Set_Rate_PCM(Sound_Rate);
		YM2612_Restore(Reg_1);
		PSG_Restore_State();
		
		if(!Init_Sound(hWnd)) return(0);

		Sound_Enable = 1;
		Play_Sound();
	}

	return(1);
}

int Change_DAC(HWND hWnd)
{
	if (DAC_Enable)
	{
		DAC_Enable = 0;
		MESSAGE_L("DAC Disabled", "DAC Disabled", 1000)
	}
	else
	{
		DAC_Enable = 1;
		MESSAGE_L("DAC Enabled", "DAC Enabled", 1000)
	}

	return(1);
}
int Change_PSG(HWND hWnd)
{
	if (PSG_Enable)
	{
		PSG_Enable = 0;
		MESSAGE_L("PSG Disabled", "PSG Disabled", 1000)
	}
	else
	{
		PSG_Enable = 1;
		MESSAGE_L("PSG Enabled", "PSG Enabled", 1000)
	}

	return 1;
}
int Change_PCM(HWND hWnd)
{
	if (PCM_Enable)
	{
		PCM_Enable = 0;
		MESSAGE_L("PCM Sound Disabled", "PCM Sound Disabled", 1000)
	}
	else
	{
		PCM_Enable = 1;
		MESSAGE_L("PCM Sound Enabled", "PCM Sound Enabled", 1000)
	}

	return 1;
}


int Change_PWM(HWND hWnd)
{
	if (PWM_Enable)
	{
		PWM_Enable = 0;
		MESSAGE_L("PWM Sound Disabled", "PWM Sound Disabled", 1000)
	}
	else
	{
		PWM_Enable = 1;
		MESSAGE_L("PWM Sound Enabled", "PWM Sound Enabled", 1000)
	}

	return 1;
}


int Change_CDDA(HWND hWnd)
{
	if (CDDA_Enable)
	{
		CDDA_Enable = 0;
		MESSAGE_L("CD Audio Sound Disabled", "CD Audio Sound Disabled", 1000)
	}
	else
	{
		CDDA_Enable = 1;
		MESSAGE_L("CD Audio Enabled", "CD Audio Enabled", 1000)
	}

	return(1);
}

int Change_Fast_Blur(HWND hWnd)
{
	Flag_Clr_Scr = 1;

	if ((Fast_Blur = (1 - Fast_Blur)))
		MESSAGE_L("Fast Blur Enabled", "Fast Blur Enabled", 1000)
	else
		MESSAGE_L("Fast Blur Disabled", "Fast Blur Disabled", 1000)

	return(1);
}

int Change_DAC_Improv(HWND hWnd)
{
	if (DAC_Improv)
	{
		DAC_Improv = 0;
		MESSAGE_L("Normal DAC sound", "Normal DAC sound", 1000)
	}
	else
	{
		DAC_Improv = 1;
		MESSAGE_L("Improved DAC sound (voices)", "Improved DAC sound (voices)", 1000)
	}

	return(1);
}

int Change_YM2612_Improv(HWND hWnd)
{
	unsigned char Reg_1[0x200];

	if (YM2612_Improv)
	{
		YM2612_Improv = 0;
		MESSAGE_L("Normal YM2612 emulation", "Normal YM2612 emulation", 1000)
	}
	else
	{
		YM2612_Improv = 1;
		MESSAGE_L("High Quality YM2612 emulation", "High Quality YM2612 emulation", 1000)
	}

	YM2612_Save(Reg_1);

	if (CPU_Mode)
	{
		YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
	}
	else
	{
		YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
	}

	YM2612_Restore(Reg_1);

	return 1;
}




int Change_PSG_Improv(HWND hWnd)
{
	if (PSG_Improv)
	{
		PSG_Improv = 0;
		MESSAGE_L("Normal PSG sound", "Normal PSG sound", 1000)
	}
	else
	{
		PSG_Improv = 1;
		MESSAGE_L("Improved PSG sound", "Improved PSG sound", 1000)
	}

	return 1;
}

int Change_YM2612(HWND hWnd)
{
	if (YM2612_Enable)
	{
		YM2612_Enable = 0;
		MESSAGE_L("YM2612 Disabled", "YM2612 Disabled", 1000)
	}
	else
	{
		YM2612_Enable = 1;
		MESSAGE_L("YM2612 Enabled", "YM2612 Enabled", 1000)
	}

	return(1);
}

int Change_SegaCD_SRAM_Size(int num)
{
	if (num == -1)
	{
		BRAM_Ex_State &= 1;
		MESSAGE_L("SegaCD SRAM cart removed", "SegaCD SRAM cart removed", 1500)
	}
	else
	{
		char bsize[256];
	
		BRAM_Ex_State |= 0x100;
		BRAM_Ex_Size = num;

		sprintf(bsize, "SegaCD SRAM cart plugged (%d Kb)", 8 << num);
		MESSAGE_L(bsize, bsize, 1500)
	}

	return 1;
}

void PlayMovie(char* MovieFileName,char* SaveStateName)
{

#if NESVIDEOS_LOGGING
    LoggingEnabled=1;
#endif

    char StateName[1024];
    strncpy(StateName,SaveStateName,1023);

    InitMovie(&MainMovie);
    strncpy(MainMovie.FileName,MovieFileName,1023);
    GetMovieInfo(MovieFileName,&MainMovie);
    OpenMovieFile(&MainMovie);

    if (MainMovie.Ok == 0)
    {
        Put_Info("Error opening file.",1500);
        MainMovie.MovieStatus = 0;
        return;
    }

    if (StateName[0] != 0)
    {
        strncpy(MainMovie.StateName,StateName,1023);
        MainMovie.UseState = 1;
    }

    MainMovie.MovieStatus = MOVIE_PLAYING;
    FrameCount=0;
    if(MainMovie.UseState)
    {
        if(MainMovie.MovieStatus==MOVIE_PLAYING)
        {
            int t = MainMovie.ReadOnly;
            MainMovie.ReadOnly = 1;
            Load_State(MainMovie.StateName);
            MainMovie.ReadOnly = t;
        }
        else
        {
            Load_State(MainMovie.StateName);
        }
        if(MainMovie.MovieStatus==MOVIE_RECORDING)
        {
            Str_Tmp[0] = 0;
            Get_State_File_Name(Str_Tmp);
            Save_State(Str_Tmp);
        }
    }
    else // not using a state
    {
        if (Genesis_Started)
        {
            Reset_Genesis();
            MESSAGE_L("Genesis reseted", "Genesis reset", 1500)
        }
        else if (_32X_Started)
        {
            Reset_32X();
            MESSAGE_L("32X reseted", "32X reset", 1500)
        }
        else if (SegaCD_Started)
        {
            Reset_SegaCD();
            MESSAGE_L("SegaCD reseted", "SegaCD reset", 1500)
        }
    }

    if(MainMovie.MovieStatus==MOVIE_PLAYING && MainMovie.UseState!=0)
    {
       if(CPU_Mode)
            sprintf(Str_Tmp, "Playing from savestate. %d frames. %d rerecords. %d min %2.2f s",MainMovie.LastFrame,MainMovie.NbRerecords-1,MainMovie.LastFrame/50/60,(MainMovie.LastFrame%3000)/60.0);
        else
            sprintf(Str_Tmp, "Playing from savestate. %d frames. %d rerecords. %d min %2.2f s",MainMovie.LastFrame,MainMovie.NbRerecords-1,MainMovie.LastFrame/60/60,(MainMovie.LastFrame%3600)/60.0);
    }
    else if(MainMovie.MovieStatus==MOVIE_PLAYING && MainMovie.UseState==0)
    {
        if(CPU_Mode)
            sprintf(Str_Tmp, "Playing from reset. %d frames. %d rerecords. %d min %2.2f s",MainMovie.LastFrame,MainMovie.NbRerecords,MainMovie.LastFrame/50/60,(MainMovie.LastFrame%3000)/60.0);
        else
            sprintf(Str_Tmp, "Playing from reset. %d frames. %d rerecords. %d min %2.2f s",MainMovie.LastFrame,MainMovie.NbRerecords,MainMovie.LastFrame/60/60,(MainMovie.LastFrame%3600)/60.0);
    }
    else
        sprintf(Str_Tmp, "Resuming recording from savestate. Frame %d.",(int)FrameCount);
    Put_Info(Str_Tmp, 4500);
}

//Modif IM - get info to start recording a new movie
//returns 1 if a reset is needed, 0 if not
void NewMovieMenu()
{
    //record a new movie
    printf("recording a new movie\n");
    char* resp;
    resp = NULL;
    //use settings from another movie file?
    while(resp == NULL || (resp[0] != 'y' && resp[0] != 'n' && resp[0] != 'q'))
    {
        if (resp) free(resp);
        resp = readline("use another movie as a template? (y/n/q):");
    }
    
    if (resp[0] == 'y')
    {
        free(resp);
        resp = readline("name of template movie :");
        //make a new movie obj
        typeMovie templateMovie;
        GetMovieInfo(resp,&templateMovie);
        free(resp);
        if (!OpenMovieFile(&templateMovie))
        {
            fprintf(stderr,"failed to open file\n");
            return;
        }
        //copy settings
        InitMovie(&templateMovie);
        CopyMovie(&templateMovie,&MainMovie);
        CloseMovieFile(&templateMovie);
        resp = readline("name of new movie :");
        if (resp[strlen(resp)-1] == ' ')
            resp[strlen(resp)-1] = 0;
        //strip out filename,nbrerecords
        strncpy(MainMovie.FileName,resp,1023);
        free(resp);
        resp = NULL;

        //write header to file
        MainMovie.File = fopen(MainMovie.FileName,"wb");
        fseek(MainMovie.File,0,SEEK_SET);
        fwrite(MainMovie.Header,16,1,MainMovie.File);
        fseek(MainMovie.File,24,SEEK_SET);
        fwrite(MainMovie.Note,40,1,MainMovie.File);
        fclose(MainMovie.File);
        if (MainMovie.File != NULL)
            MainMovie.Ok = 1;
        MainMovie.File=NULL;
        OpenMovieFile(&MainMovie);
        MainMovie.NbRerecords = 1;

        resp = readline("start movie from now, reset or state (n/r/s):");
        while (resp[0] != 'n' && resp[0] != 'r' && resp[0] != 's')
        {
            free(resp);
            resp = readline("start movie from now, reset or state (n/r/s):");
        }
        
        if (resp[0] == 'r') //start from reset
        {
            MainMovie.LastFrame = 0;
            MainMovie.StateRequired = 0;
            FrameCount = 0;
            system_reset();
        }
        else if (resp[0] == 's')
        {
            free(resp);
            resp = readline("name of state:");
            Load_State(resp);
            MainMovie.LastFrame = FrameCount;
            MainMovie.StateRequired = 1;
        }
        else
        {
            MainMovie.LastFrame = FrameCount;
            MainMovie.StateRequired = 1;
        }
        free(resp);
        MainMovie.MovieStatus = MOVIE_RECORDING;
        PrintMovie(&MainMovie);
    } 
    else if (resp[0] == 'n') //don't use a template
    { 
        free(resp);
        InitMovie(&MainMovie);
        
        //prompt: filename (attempt to create/open)
        resp = readline("name of new movie :");
        //tab-completion adds a space at the end
        if (resp[strlen(resp)-1] == ' ')
            resp[strlen(resp)-1] = 0;
        strncpy(MainMovie.FileName,resp,1023);
        free(resp);
        
        //prompt: 3-player?
        resp = readline("use 3-player hack? (y/n):");
        if (resp[0] == 'y')
        {
            MainMovie.TriplePlayerHack = 1;
            MainMovie.Player1Config = '3';
            MainMovie.Player2Config = '3';
        }
        else
        {
            //prompt: controller settings
            resp = readline("controller 1 configuration (3/6):");
            if (resp[0] == '3')
                MainMovie.Player1Config = '3';
            else
                MainMovie.Player1Config = '6';
            free(resp);

            resp = readline("controller 2 configuration (3/6):");
            if (resp[0] == '3')
                MainMovie.Player2Config = '3';
            else
                MainMovie.Player2Config = '6';
            free(resp);
        }
        //prompt: movie note
        resp = readline("movie note:");
        strncpy(MainMovie.Note,resp,40);
        MainMovie.Note[40] = 0;
        
        //prompt: start from this state?
        resp = readline("start movie from now, reset or state (n/r/s):");
        while (resp[0] != 'n' && resp[0] != 'r' && resp[0] != 's')
        {
            free(resp);
            resp = readline("start movie from now, reset or state (n/r/s):");
        }
        
        if (resp[0] == 'r') //start from reset
        {
            MainMovie.LastFrame = 0;
            MainMovie.StateRequired = 0;
            system_reset();
            FrameCount = 0;
        }
        else if (resp[0] == 's')
        {
            free(resp);
            resp = readline("name of state:");
            Load_State(resp);
            MainMovie.LastFrame = FrameCount;
            MainMovie.StateRequired = 1;
        }
        else
        {
            MainMovie.LastFrame = FrameCount;
            MainMovie.StateRequired = 1;
        }
        free(resp);

        //write header to file
        strncpy(MainMovie.Header,"Gens Movie TESTA",17);
        MainMovie.Version='A'-'0';
        MainMovie.File = fopen(MainMovie.FileName,"wb");
        fseek(MainMovie.File,0,SEEK_SET);
        fwrite(MainMovie.Header,16,1,MainMovie.File);
        fseek(MainMovie.File,24,SEEK_SET);
        fwrite(MainMovie.Note,40,1,MainMovie.File);
        fclose(MainMovie.File);
        if (MainMovie.File != NULL)
            MainMovie.Ok = 1;
        MainMovie.File=NULL;
        OpenMovieFile(&MainMovie);
        MainMovie.NbRerecords = 1;
        MainMovie.MovieStatus = MOVIE_RECORDING;
        MainMovie.ReadOnly = 0;
    }
}
